#!/usr/bin/perl
# -*- perl -*-

%dvi=(
	'Installation and Getting Started', '%d gs.dvi %f',
	'Plug and Play Manual','%d manual.dvi %f',
	'Kernel Hackers Guide', '%d khg.dvi %f',
	'Linux Programmers Guide', '%d lpg.dvi %f',
	'Network Administrators Guide', '%d nag.dvi %f',
	'System Administrators Guide', '%d sag.dvi %f',
	'Users Guide', '%d guide.dvi %f',
	'Lilo Users', '%d user.dvi %f',
	'Lilo Tech', '%d tech.dvi %f',
	'Bootdisk Howto', '%d Bootdisk-HOWTO.dvi %f',
	'Bus Mouse Howto', '%d Busmouse-HOWTO.dvi %f',
	'CD-Rom Howto', '%d CDROM-HOWTO.dvi %f',
	'Commercial Howto', '%d Commercial-HOWTO.dvi %f',
	'Danish Howto', '%d Danish-HOWTO.dvi %f',
	'Device List', '%d device.dvi %f',
	'DOS Emulator Howto', '%d DOSEMU-HOWTO.dvi %f',
	'Distribution Howto', '%d Distribution-HOWTO.dvi %f',
	'Ethernet Howto', '%d Ethernet-HOWTO.dvi %f',
	'ELF Howto', '%d ELF-HOWTO.dvi %f',
	'Firewall Howto', '%d Firewall-HOWTO.dvi %f',
	'Ftape Howto', '%d Ftape-HOWTO.dvi %f',
	'Hardware Howto', '%d Hardware-HOWTO.dvi %f',
	'Ham Howto', '%d HAM-HOWTO.dvi %f',
	'HOWTO-INDEX', '%d HOWTO-INDEX.dvi %f',
	'Installation Howto', '%d Installation-HOWTO.dvi %f',
	'Japanese Extenstion (JE) Howto', '%d je.dvi %f',
	'Kernel Howto', '%d Kernel-HOWTO.dvi %f',
	'Keystroke Howto', '%d Keystroke-HOWTO.dvi %f',
	'MGR Howto', '%d MGR-HOWTO.dvi %f',
	'Mail Howto', '%d Mail-HOWTO.dvi %f',
	'Net2 Howto', '%d NET-2-HOWTO.dvi %f',
	'NIS Howto', '%d NIS-HOWTO.dvi %f',
	'UPS Howto', '%d UPS-HOWTO.dvi %f',
	'Usenet News Howto', '%d News-HOWTO.dvi %f',
	'PCI Howto', '%d PCI-HOWTO.dvi %f',
	'PCMCIA Howto','%d PCMCIA-HOWTO.dvi %f',
        'PPP Howto', '%d PPP-HOWTO.dvi %f',
	'Printing Howto','%d -p=1 -l=1 printing.dvi %f; %d -p `expr %s + 2` printing.dvi %f ;%d -p=2 -l %e printing.dvi %f',
	'SCSI Howto', '%d SCSI-HOWTO.dvi %f',
	'SCSI Programming Howto','%d SCSI-Programming-HOWTO.dvi %f',
	'Serial Howto', '%d Serial-HOWTO.dvi %f',
	'Sound Howto', '%d Sound-HOWTO.dvi %f',
	'Term Howto', '%d Term-HOWTO.dvi %f',
	'Tips Howto', '%d Tips-HOWTO.dvi %f',
	'UUCP Howto', '%d UUCP-HOWTO.dvi %f',
	'WINE FAQ', '%d wine.dvi %f',
	'XFree86 Howto', '%d XFree86-HOWTO.dvi %f'
      );

%idx=(
	'Installation and Getting Started', 'cat gs.idx',
	'Kernel Hackers Guide', 'cat khg.idx',
	'Network Administrators Guide', 'cat index/nag.idx',
	'Users Guide', 'cat guide.idx',
	'Printing Howto','../info2idx.pl printing.pg printing.fn printing.cp',
      );

%parts=(
	'Installation and Getting Started', '* install-guide-2.2.2 gs-page.tex latex gs.tex',
	'Plug and Play Manual','Yggdrasil . manual-pag.tex tex manual.texinfo >/dev/null; dvips -M -f <manual.dvi >/dev/null',
	'Kernel Hackers Guide', '* khg-0.6 khg-page.tex latex khg.tex',
	'Linux Programmers Guide', '* LPG lpg-page.tex latex lpg.tex',
	'Network Administrators Guide', '* TheGuide nag-page.tex make clean; make all',
	'System Administrators Guide', '* sag-0.2 sag-page.tex /usr/TeX/bin/latex sag.tex',
	'Users Guide', '* user-alpha-4 user-page.tex /usr/TeX/bin/latex guide.tex',
	'Lilo Users', 'LILO lilo lilou-pag.tex rm -f user.dvi; make user.dvi',
	'Lilo Tech', 'LILO lilo lilot-pag.tex rm -f tech.dvi; make tech.dvi',
	'Bootdisk Howto', 'bootdisk HOWTO-src bootdisk-pag.tex latex Bootdisk-HOWTO.tex',
	'Bus Mouse Howto', 'bus~mouse HOWTO-src busmouse-pag.tex latex Busmouse-HOWTO.tex',
	'CD-Rom Howto', 'CD-ROM HOWTO-src cdrom-pag.tex latex CDROM-HOWTO.tex',
	'Commercial Howto', 'commercial HOWTO-src commercial-pag.tex latex Commercial-HOWTO.tex',
	'Danish Howto', 'Danish HOWTO-src danish-pag.tex latex Danish-HOWTO.tex',
	'Device List', 'devices . device-pag.tex latex device.tex',
	'DOS Emulator Howto', 'DOSEMU HOWTO-src dosemu-pag.tex latex DOSEMU-HOWTO.tex',
	'Distribution Howto', '* HOWTO-src dist-pag.tex latex Distribution-HOWTO.tex',
	'ELF Howto', 'ELF HOWTO-src elf-pag.tex latex ELF-HOWTO.tex',
	'Ethernet Howto', 'ethernet HOWTO-src ether-pag.tex latex Ethernet-HOWTO.tex',
	'Firewall Howto', 'firewall HOWTO-src firewall-pag.tex latex Firewall-HOWTO.tex',
	'Ftape Howto', 'ftape HOWTO-src ftape-pag.tex latex Ftape-HOWTO.tex',
	'Ham Howto', 'ham~radio HOWTO-src ham-pag.tex latex HAM-HOWTO.tex',
	'Hardware Howto', '* HOWTO-src hardware-pag.tex latex Hardware-HOWTO.tex',
	'HOWTO-INDEX', '* HOWTO-src howtoidx-pag.tex latex HOWTO-INDEX.tex',
	'Installation Howto', 'installation HOWTO-src install-pag.tex latex Installation-HOWTO.tex',
	'Kernel Howto', 'kernel HOWTO-src kernel-pag.tex latex Kernel-HOWTO.tex',
	'Japanese Extenstion (JE) Howto', 'Japanese howtos je-pag.tex latex je.tex',
	'Keystroke Howto', 'keymap HOWTO-src key-pag.tex latex Keystroke-HOWTO.tex',
	'MGR Howto', 'MGR HOWTO-src mgr-pag.tex latex MGR-HOWTO.tex',
	'Mail Howto', 'mail HOWTO-src mail-pag.tex latex Mail-HOWTO.tex',
	'Net2 Howto', 'networking HOWTO-src net2-pag.tex latex NET-2-HOWTO.tex',
	'NIS Howto', 'NIS HOWTO-src nis-pag.tex latex NIS-HOWTO.tex',
	'Usenet News Howto', 'news HOWTO-src news-pag.tex latex News-HOWTO.tex',
	'PCMCIA Howto', 'pcmcia HOWTO-src pcmcia-pag.tex latex PCMCIA-HOWTO.tex',
	'PPP Howto', 'ppp HOWTO-src ppp-pag.tex latex PPP-HOWTO.tex',
	'PCI Howto', 'PCI HOWTO-src pci-pag.tex latex PCI-HOWTO.tex',
	'Printing Howto','printing howtos printing-pag.tex tex printing.texinfo',
	'SCSI Howto', 'SCSI HOWTO-src scsi-pag.tex latex SCSI-HOWTO.tex',
	'SCSI Programming Howto', 'SCSI HOWTO-src scsiprog-pag.tex latex SCSI-Programming-HOWTO.tex',
	'Serial Howto', 'serial HOWTO-src serial-pag.tex latex Serial-HOWTO.tex',
	'Sound Howto', 'sound HOWTO-src sound-pag.tex latex Sound-HOWTO.tex',
	'Term Howto', 'term HOWTO-src term-pag.tex latex Term-HOWTO.tex',
	'Tips Howto', '* HOWTO-src tips-pag.tex latex Tips-HOWTO.tex',
	'UPS Howto', 'UPS HOWTO-src ups-pag.tex latex UPS-HOWTO.tex',
	'UUCP Howto', 'UUCP HOWTO-src uucp-pag.tex latex UUCP-HOWTO.tex',
	'WINE FAQ', 'WINE . wine-pag.tex latex wine.tex',
	'XFree86 Howto', 'XFree86 HOWTO-src xfree86-pag.tex latex XFree86-HOWTO.tex'
);

@parts=('****VOLUME****',
	'Installation and Getting Started',
#	'Plug and Play Manual',
	'Kernel Hackers Guide',
	'Network Administrators Guide',
	'System Administrators Guide',
	'Users Guide',
#	'Linux Programmers Guide',
	'Lilo Users',
	'Lilo Tech',
	'HOWTO-INDEX',
	'Bootdisk Howto',
	'Bus Mouse Howto',
	'CD-Rom Howto',
	'Commercial Howto',
	'Danish Howto',
	'Device List',
	'DOS Emulator Howto',
	'Distribution Howto',
	'ELF Howto',
	'Ethernet Howto',
	'Firewall Howto',
	'Ftape Howto',
	'Ham Howto',
	'Hardware Howto',
	'Installation Howto',
	'Japanese Extenstion (JE) Howto',
	'Kernel Howto',
	'Keystroke Howto',
	'MGR Howto',
	'Mail Howto',
	'Net2 Howto',
	'NIS Howto',
	'Usenet News Howto',
	'PCI Howto',
	'PCMCIA Howto',
	'PPP Howto',
	'Printing Howto',
	'SCSI Howto',
	'SCSI Programming Howto',
	'Serial Howto',
	'Sound Howto',
	'Term Howto',
	'Tips Howto',
	'UPS Howto',
	'UUCP Howto',
	'WINE FAQ',
	'XFree86 Howto',
	'****VOLUME****'
);

#
#@parts=(
#	'****VOLUME****',
#	'Installation and Getting Started',
#	'Plug and Play Manual',
#	'Users Guide',
#	'Lilo Users', 
#	'HOWTO-INDEX',
#	'Bus Mouse Howto',
#	'CD-Rom Howto',
#	'Distribution Howto',
#	'Ethernet Howto',
#	'Ftape Howto',
#	'Hardware Howto',
#	'Installation Howto',
#	'PCI Howto',
#	'SCSI Howto',
#	'Serial Howto',
#	'Sound Howto',
#	'Tips Howto',
#	'****VOLUME****',
#	'Network Administrators Guide',
#	'System Administrators Guide',
#	'Kernel Hackers Guide',
#	'Lilo Tech', 
#	'HOWTO-INDEX',
#	'DOS Emulator Howto',
#	'Japanese Extenstion (JE) Howto',
#	'Keystroke Howto',
#	'MGR Howto',
#	'Mail Howto',
#	'Net2 Howto',
#	'NIS Howto',
#	'Usenet News Howto',
#	'Printing Howto',
#	'Term Howto',
#	'UUCP Howto',
#	'WINE FAQ',
#	'XFree86 Howto'
#);
require "getopts.pl";
&Getopts ("h");
$pwd=`pwd`;
chop $pwd;
if ($opt_h) {
    for $part (@parts) {
	chdir ($pwd) || die "Unable to change directory back to $pwd";
	($idx, $dir, $pagefile, $command)=split (/\s+/,$parts{$part},4);
	print "idx=$idx part=$part dir=$dir, pagefile=$pagefile, command=$command\n";
	next unless ($command=~/\s+(\S+).tex/);

	if (! chdir($dir)) {
	    print "Error Unable to cd to $dir.  Skipping $part\n";
	    next;
	}

	$file = "$1.tex";
	$found_line = 0;
	open (FILE, "<$file") || (print stderr "Unable to open $file\n", next);
	while (<FILE>) {
	    last if (/^input .*$pagefile$/);
	    if (/$pagefile/) {
		$found_line = 1;
		last;
	    }
	}
	close (FILE);
	next if ($found_line);

	rename ($file, "$file.bak");
	open (FILE, "<$file.bak") || (print stderr "Unable to open $file\n", chdir ($pwd), next);

	open (FILE2, ">$file") || (print stderr "Unable to open $file\n", chdir ($pwd), next);

	print FILE2 "\\input /home/biro/bible/$pagefile\n";
	while (<FILE>) {
	    next if (/^input .*$pagefile$/);
	    if (/\\documentstyle/) {
		s/null/twoside,times/;
	    }
	    print FILE2 $_;
	}
	close (FILE);
	close (FILE2);
    
    }
    exit (0);
}


$dvipscommand="dvips -T 7,9.25 -k -s -a -Z -f";
$page=0;
$lpage=0;
$partno=0;
$volume=0;
open (CF,">contents.tex") || die ("unable to open contents.tex");
for $part (@parts) {
    $page=$page+1;
    if ($part eq '****VOLUME****') {
	close (IDX);
	if ($indexfile) {
	    system ("makeindex $indexfile");
	    open (OF,">index$volume-pag.tex") || die ("unable to open index$volume-pag.tex");
	    print OF "\\nonstopmode\n";
	    print OF "\\mag=825\n";
	    print OF "\\def\\myhsize{". 5.4/.825 ." in }\n";
	    print OF "\\def\\myvsize{". 8.25/.825 ." in }\n";
	    print OF "\\def\\firstpageno{$page}\n";
	    print OF "\\def\\firstpartno{$partno}\n";
	    print OF "\\setcounter{page}{\\firstpageno}\n";
	    print OF "\\def\\firstpartno{$partno}\n";
	    close (OF);
	    system ("cat vol$volume-index.top vol$volume.ind vol$volume-index.bot >vol$volume-index.tex");
	    system ("latex vol$volume-index.tex");
	    system ("$dvipscommand vol$volume-index.dvi >>$psfile");
	}
	$volume++;
	$indexfile="vol$volume.idx";
	unlink ($indexfile);
	open (IDX, ">$indexfile") || die ("unable to open vol$volume.idx");
	$oldfh = select(IDX);
	$|=1;
	select($oldfh);
	print CF "\\volume\n";
	$psfile = "volume$volume.ps";
	# XXXXX FIXME!!!!! XXXXX Put preface, and  such here.
	unlink ($psfile);
	$page=0;
	$partno=0;
	next;
    }
    ($idx, $dir, $pagefile, $command)=split (/\s+/,$parts{$part},4);
    if ( $idx ne '*' ) {
	print "\\indexentry{$idx|(}{$page}\n";
	print IDX "\\indexentry{$idx|(}{$page}\n";
    }
    print "idx=$idx part=$part dir=$dir, pagefile=$pagefile, command=$command\n";
    open (OF,">$pagefile") || die ("unable to open $pagefile");
    print OF "\\nonstopmode\n";
    print OF "\\mag=825\n";
    print OF "\\def\\myhsize{". 5.4/.825 ." in }\n";
    print OF "\\def\\myvsize{". 8.25/.825 ." in }\n";
    print OF "\\def\\firstpageno{$page}\n";
    print OF "\\def\\firstpartno{$partno}\n";
    close (OF);
    $partno=$partno+1;
    print CF "\\contpart{$part}{$partno}{$page}\n";
    if (! chdir($dir)) {
	print "Error Unable to cd to $dir.  Skipping $part\n";
	next;
    }
    undef $output;
    "abc" =~ /(.)(.)/;
    $output=`( $command )</dev/null 2>&1`;
    #$output =~ s/\n//g;
    if (! $output ) {
	print "Error Unable to execute $command for part $part\n";
	next;
    }
    $1=0;
    $output =~ /\[([0-9]+)\]/;
    $page=$1 if ($1 > $page);

    while ($'=~ /\[([0-9]+)\]/) {
	 $page=$1 if ($1 > $page);
    };
    if ( $idx ne '*' ) {
	print "\\indexentry{$idx|)}{$page}\n";
	print IDX "\\indexentry{$idx|)}{$page}\n";
    }
    print "Last page of $part = $page\n";

    $dvicommand = $dvi{$part};
    $indexcommand = $idx{$part};

    $dvicommand =~ s/%d/$dvipscommand/g;
    $dvicommand =~ s/%f/>>$pwd\/$psfile/g;
    $dvicommand =~ s/%e/$page/g;
    $dvicommand =~ s/%s/$lpage/g;
    $lpage = $page;
    print "$dvicommand \n";
    
    system ("$dvicommand");
    if ($indexcommand) {
	system ("$indexcommand >>$pwd/$indexfile");
    }
    
    chdir ($pwd) || die "Unable to change directory back to $pwd";
}
close (IDX);
close (CF);









