.\" $Id: tkfb.man,v 2.0 1993/01/14 23:27:41 schwartz Exp $
.TH TKFB 1 "13 December 1992"
.SH NAME
tkfb \- tk based file browser with drag-and-drop
.SH SYNOPSIS
.B tkfb
[
.I path
]
.SH REQUIREMENTS
This program is known to work with tk2.3 plus Michael J. McLennan's
drag&drop patches.
.SH DESCRIPTION
.LP
.B tkfb
is a graphical drag and drop based file browser.  It gives you a way
select and manipulate pathnames and transmit them to cooperating
applications using a direct manipulation interface.
.LP
If no argument is given 
.B tkfb 
will present a view of the current directory path.  Otherwise the
first argument will be interpreted as a path and presented.
The brower's presentation consists of 
a graphical interface with four parts.  
.LP 
The top of the window
contains a menu bar with items labeled 
.I Quit,
.I Clone,
.I Edit,
.I Exec.
and
.I Reify.
Quit exits the program.  
Clone launches a new copy of the browser initialized with the current path.
Edit launches an editor in an xterm on the selected file.  Exec
executes the selected file with standard io connected to an xterm.
Reify launches an 
.B tkdrop
application, initialized properly according to the currently
selected object.
.LP
The second part of the interface is an entry widget.  This widget
will accept a new pathname typed from the keyboard or pasted with
the mouse.  At other times it displays the 
currently selected path, and makes that path available as the X PRIMARY
selection.  At all times, the contents of the entry widget may
be dragged or dropped with mouse button 3.
.LP
The third part of the interface is a label that contains information
about the current selection, such as owner and size.
.LP 
The fourth part of the interface is a sequence of five panes which
contain a label holding
the name of the directory component represented in that pane,
and a listbox holding the contents of that directory (except
in the case of the last component, which may be a file.)
Selecting an entry in a listbox sets the subsequent pane to
the contents of that entry, except for the case of ``.''.
Double clicking will execute the entry if it is marked as executable,
and edit it otherwise.
Pressing a label truncates the pathame at that point.
The labels may
also have their path selected for dragging with mouse button 3.
.LP
In the brower panes, the left and right arrow keys will scroll the
entire view.  In individual panes the up and down arrows, the PageUp and
PageDown, and the Home and End keys will perform their respective
functions.
.SH AUTHOR
Scott Schwartz <schwartz@cs.psu.edu>

Thanks to Dan Grillo <grio@cs.psu.edu> and Felix Lee <flee@cs.psu.edu>
for lots of feedback.

.SH BUGS
It would be nice to have multiple fonts in listboxes.

Listboxes really need to support multiple non-contiguous selections.

Tkfb needs to know how to deal with multiple selections.

There is no way to do mutual exclusion in tk, so it is quite possible
for things to get stomped;  the periodic update is often the cause of
that.

Sun's automounter doesn't return correct timestamp information for
automount points.  (I work around that, but don't like it.)

The application should resize gracefully.

Helper programs, like tkdrop, need to be developed some more.

There doesn't seem to be a way to set the class from tk:  it defaults
to "name" + "#n", which is wrong.

How can you redirect stderr in exec?

Exec with an & should do a setsid in SunOS 4.1 and later.

The tk options stuff is bizarre.  "*Font" in .Xdefaults overrides
"Tk*Tkfb*Font" in the program??  And why is the "Tk" needed to get it
to work at all, when I have set the app class name to be Tkfb?

Others to be announced.
